/*
 * AMIGA.H (VEC)
 *
 * Copyright (c) 1993 Ville Saari
 * All rights reserved
 *
 * Created: 07-Apr-93
 * Updated: 04-Dec-93
 */

#include <proto/dos.h>

#ifdef _M86040
	#define SYSTEM    "a040"
#elif defined(_M68030)
	#define SYSTEM    "a030"
#elif defined(_M68020)
	#define SYSTEM    "a020"
#elif defined(_M68010)
	#define SYSTEM    "a010"
#else
	#define SYSTEM    "a"
#endif

#define COPYRSIGN "\251"
#define BOLDON    "\2331m"
#define BOLDOFF   "\2330m"
#define DEFMETHOD '3'
#define DEFWIDTH  77
#define DEFWIDTHS "77"
#define OK        0
#define WARN      5
#define ERROR     10
#define FAIL      20
#define BUFSIZE   65536

#define VERSTRING "$VER: " ENAME "/" DNAME " " RELEASE "." VERSION SYSTEM " (" VERDATE ")"

typedef BPTR filehandle;

#define interrupt()             CheckSignal(SIGBREAKF_CTRL_C)
#define getstdin(bin)           Input()
#define getstdout(bin)          Output()
#define openread(name, bin)     Open((char *)(name), MODE_OLDFILE)
#define openwrite(name, bin)    Open((char *)(name), MODE_NEWFILE)
#define failedopen(fh)          (!(fh))
#define closefile(fh)           Close(fh)
#define readfile(fh, buf, sz)   Read(fh, buf, sz)
#define writefile(fh, buf, sz)  Write(fh, (char *)(buf), sz)
#define modifyname(name, count) strcat(strcat((name), "_"), ltoa(count))
